/*

		gWX^Zp@QOOXNU

	WindowsAvP[VETvpt@[EFA


			Copyright 2009, Yoshi Hiroshi.

 */

#include <avr/io.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>

volatile unsigned char previousPortdValue;
volatile unsigned char commandPort;
volatile unsigned char commandDataH;
volatile unsigned char commandDataL;
volatile unsigned char commandRequest;
volatile unsigned char recieveBuff[4];
volatile unsigned char recieveLength;
volatile unsigned char sendBuff[6];
volatile int sendLength;

unsigned char portVal;

void Init();
unsigned char GetSwitch();
unsigned char GetLedPort();
void SetLedPort(unsigned char val);
unsigned char RecieveCommand();
void DoCommand(unsigned char cmnd);
void CheckPortChange();
void SendResultData();
void LedTest();

#define GET_HEX_BYTE(h) ((((h) >= 'a')? ((h) - 'a' + 10):(((h) >= 'A')? ((h) - 'A' + 10):((h) - '0'))) & 0x0F)
#define GET_HEX_CHAR(h) (((h) > 9)? ((h) + 'A' - 10):((h) + '0'))

/*---------------------------------------------
 *
 *		C[`
 *
 */
int main()
{
	Init();
	LedTest();
	while(1)
	{
		commandRequest = RecieveCommand();		// R}h̎M
		if(sendLength <= 0)
		{
			DoCommand(commandRequest);			// R}h̎s
			commandRequest = 0;
		}
		if(sendLength <= 0) CheckPortChange();	// |[gω̃`FbN
		if(sendLength > 0) SendResultData();	// f[^̑M
	}
}

/*---------------------------------------------
 *
 *		Get Switch Value
 *
 */
unsigned char GetSwitch()
{
	unsigned char pd = PIND & 0x7C;
	unsigned char pa = PINA & 0x03;
	return (pd | pa); 
}

/*---------------------------------------------
 *
 *		Get LED Value
 *
 */
unsigned char GetLedPort()
{
	return PINB;
}

/*---------------------------------------------
 *
 *		Set LED
 *
 */
void SetLedPort(unsigned char val)
{
	PORTB = val;
}

/*---------------------------------------------
 *
 *		
 *
 */
void Init()
{
// Init PORTA
	PORTA = 0x03;						// PA0, PA1vAbv
// Init PORTB
	DDRB = 0xFF;						// PORTBo͂Ƃ

// Init PORTD
	PORTD = 0x7C;						// PORTD͂ƂăvAbv

// Init USART
	UBRRH = 0;							// 9600 baud
	UBRRL = 12;							//
	UCSRA = _BV(U2X);					// 
	UCSRB = _BV(RXEN) | _BV(TXEN);		// RECIEVE/TRANSMIT ENABLE
	UCSRC = _BV(UCSZ1) | _BV(UCSZ0);	// 8bit

// Init Command Buffer
	recieveLength = 0;
	sendBuff[4] = 0x0D;
	sendBuff[5] = 0x0A;
	sendLength = 0;
	previousPortdValue = GetSwitch();
}

/*---------------------------------------------
 *
 *		R}h̎M
 *
 */
unsigned char RecieveCommand()
{
	unsigned char result = 0;
	if((UCSRA & _BV(RXC)) != 0)		// f[^MH
	{
		portVal = UDR;
		switch(portVal)
		{
		case 0x0D:
		case 0x0A:					// CR/LFł̓obt@
			recieveLength = 0;
			break;
		default:
			if(recieveLength < 4)	// obt@TCYȓȂA
				recieveBuff[recieveLength++] = portVal;		// f[^obt@Ɋi[
			break;
		}
		if(recieveLength > 1)
		{
			switch(recieveBuff[0])
			{
			case 'R':
			case 'r':
				if(recieveLength == 2) result = 'R';
				break;
			case 'W':
			case 'w':
				if(recieveLength == 4) result = 'W';
				break;
			default:
				break;
			}
		}
		if(result)
		{
			commandPort = recieveBuff[1];
			commandDataH = recieveBuff[2];
			commandDataL = recieveBuff[3];
			recieveLength = 0;
		}
	}
	return result;
}


/*---------------------------------------------
 *
 *		R}h̎s
 *
 */
void DoCommand(unsigned char cmnd)
{
	unsigned char work1, work2;
	unsigned char commandExist = 0;
	switch(cmnd)
	{
	case 'R':
		if((commandPort == 'B') || (commandPort == 'b'))
		{
			portVal = GetLedPort();
			commandExist = 1;
		}
		if((commandPort == 'D') || (commandPort == 'd'))
		{
			portVal = GetSwitch();
			commandExist = 1;
		}
		if(commandExist)
		{
			sendBuff[0] = 'P';
			sendBuff[1] = commandPort & 0xDF;
			work1 = (portVal >> 4) & 0x0F;
			sendBuff[2] = GET_HEX_CHAR(work1);
			work2 = portVal & 0x0F;
			sendBuff[3] = GET_HEX_CHAR(work2);
			sendLength = 6;
		}
		break;
	case 'W':
		if((commandPort == 'B') || (commandPort == 'b'))
		{
			portVal = (GET_HEX_BYTE(commandDataH) << 4) | GET_HEX_BYTE(commandDataL);
			SetLedPort(portVal);
		}
		break;
	default:
		break;
	}
}

/*---------------------------------------------
 *
 *		|[g̕ωo
 *
 */
void CheckPortChange()
{
	unsigned char work;
	if(previousPortdValue != GetSwitch())
	{
		previousPortdValue = GetSwitch();
		sendBuff[0] = 'C';
		sendBuff[1] = 'D';
		work = (previousPortdValue >> 4) & 0x0F;
		sendBuff[2] = GET_HEX_CHAR(work);
		work = previousPortdValue & 0x0F;
		sendBuff[3] = GET_HEX_CHAR(work);
		sendLength = 6;
	}
}

/*---------------------------------------------
 *
 *		f[^̑M
 *
 */
void SendResultData()
{
	if((UCSRA & _BV(UDRE)) != 0)
	{
		portVal = sendBuff[6 - sendLength--];
		UDR = portVal;
	}
}

/*---------------------------------------------
 *
 *		LED̕\eXg
 *
 */
extern unsigned char EEMEM testPatternE[];
extern unsigned char PROGMEM testPatternP[];
int GetPatternSizeE();
int GetPatternSizeP();

void LedTest()
{
	volatile unsigned char switchNow = GetSwitch();
	volatile int countMax;
	int dataCount = 0xFFF;
	int dataMax;

	while((switchNow & 0x10) != 0)
	{
		countMax = ((switchNow & 0x08) != 0)? 5000 : 1250;
		countMax = ((switchNow & 0x04) != 0) ? countMax * 2 : countMax;
		dataMax = ((switchNow & 0x01) != 0) ? GetPatternSizeE() : GetPatternSizeP();
		dataCount++;
		if(dataCount >= dataMax) dataCount = 0;
		if((switchNow & 0x01) != 0)
		{
			SetLedPort(eeprom_read_byte(&testPatternE[dataCount]));
		}
		else
		{
			SetLedPort(pgm_read_byte(&testPatternP[dataCount]));
		}
		for(volatile int waitCount = 0; waitCount < countMax; waitCount++);
		switchNow = GetSwitch();
	}
	SetLedPort(0);
}

unsigned char EEMEM testPatternE[] =
{
	0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,
	0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,

	0b10000000,
	0b11000000,
	0b11100000,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b00000111,
	0b00000011,
	0b00000001,
	0b10000000,
	0b11000000,
	0b11100000,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b00000111,
	0b00000011,
	0b00000001,
	0b00000000,
	0b00000001,
	0b00000011,
	0b00000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100000,
	0b11000000,
	0b10000000,
	0b00000000,
	0b00000001,
	0b00000011,
	0b00000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100000,
	0b11000000,
	0b10000000,
	0b00000000,

	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,

	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000011,
	0b00000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111111,

	0xFF,
	0x00, 
	0x00,
	0x00
};


int GetPatternSizeE()
{
	return sizeof(testPatternE);
}


unsigned char PROGMEM testPatternP[] =
{
	0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,
	0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,

	0b10000000,
	0b11000000,
	0b11100000,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b00000111,
	0b00000011,
	0b00000001,
	0b10000000,
	0b11000000,
	0b11100000,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b00000111,
	0b00000011,
	0b00000001,
	0b10000000,
	0b11000000,
	0b11100000,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b00000111,
	0b00000011,
	0b00000001,
	0b00000000,
	0b00000001,
	0b00000011,
	0b00000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100000,
	0b11000000,
	0b10000000,
	0b00000001,
	0b00000011,
	0b00000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100000,
	0b11000000,
	0b10000000,
	0b00000000,
	0b00000001,
	0b00000011,
	0b00000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100000,
	0b11000000,
	0b10000000,

	0b00000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b10000000,
	0b11000000,
	0b11100000,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b00000111,
	0b00000011,
	0b00000001,



	0b00000000,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b00000001,
	0b00000011,
	0b00000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100000,
	0b11000000,
	0b10000000,


	0b00000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b11000000,
	0b11100000,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b00000111,
	0b00000011,
	0b00000001,

	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,
	0b00000011,
	0b00000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100000,
	0b11000000,
	0b10000000,


	0b10000000,
	0b01000000,
	0b00100000,
	0b00010000,
	0b10001000,
	0b01000100,
	0b00100010,
	0b00010001,
	0b10001000,
	0b01000100,
	0b00100010,
	0b00010001,
	0b10001000,
	0b01000100,
	0b00100010,
	0b00010001,
	0b10001000,
	0b01000100,
	0b00100010,
	0b00010001,
	0b00001000,
	0b00000100,
	0b00000010,
	0b00000001,

	0b10000000,
	0b11000000,
	0b01100000,
	0b00110000,
	0b00011000,
	0b00001100,
	0b00000110,
	0b00000011,
	0b00000001,
	0b10000000,
	0b11000000,
	0b01100000,
	0b00110000,
	0b00011000,
	0b00001100,
	0b00000110,
	0b00000011,
	0b00000001,
	0b10000000,
	0b11000000,
	0b01100000,
	0b00110000,
	0b00011000,
	0b10001100,
	0b11000110,
	0b01100011,
	0b00110001,
	0b00011000,
	0b10001100,
	0b11000110,
	0b01100011,
	0b00110001,
	0b00011000,
	0b10001100,
	0b11000110,
	0b01100011,
	0b00110001,
	0b00011000,
	0b10001100,
	0b11000110,
	0b11100011,
	0b01110001,
	0b00111000,
	0b00011100,
	0b10001110,
	0b11000111,
	0b11100011,
	0b11110001,
	0b01111000,
	0b00111100,
	0b00011110,
	0b10001111,
	0b11000111,
	0b11100011,
	0b11110001,
	0b11111000,
	0b01111100,
	0b00111110,
	0b00011111,
	0b10001111,
	0b11000111,
	0b11100011,
	0b11110001,
	0b11111000,
	0b11111100,
	0b01111110,
	0b00111111,
	0b00011111,
	0b10001111,
	0b11000111,
	0b11100011,
	0b11110001,
	0b11111000,
	0b11111100,
	0b11111110,
	0b11111111,
	0b11111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110001,
	0b11100011,
	0b11000111,
	0b10001111,
	0b00011111,
	0b00111111,
	0b01111110,
	0b11111100,
	0b11111000,
	0b11110001,
	0b11100011,
	0b11000111,
	0b10001111,
	0b00011111,
	0b00111110,
	0b01111100,
	0b11111000,
	0b11110001,
	0b11100011,
	0b11000111,
	0b10001111,
	0b00011110,
	0b00111100,
	0b01111000,
	0b11110001,
	0b11100011,
	0b11000111,
	0b10001110,
	0b00011100,
	0b00111000,
	0b01110001,
	0b11100011,
	0b11000110,
	0b10001100,
	0b00011000,
	0b00110001,
	0b01100011,
	0b11000110,
	0b10001100,
	0b00011000,
	0b00110001,
	0b01100011,
	0b11000110,
	0b10001100,
	0b00011000,
	0b00110001,
	0b01100011,
	0b11000110,
	0b10001100,
	0b00011000,
	0b00110000,
	0b01100000,
	0b11000000,
	0b10000000,
	0b00000001,
	0b00000011,
	0b00000110,
	0b00001100,
	0b00011000,
	0b00110000,
	0b01100000,
	0b11000000,
	0b10000000,
	0b00000001,
	0b00000011,
	0b00000110,
	0b00001100,
	0b00011000,
	0b00110000,
	0b01100000,
	0b11000000,
	0b10000000,

	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,
	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,

	0b00000001,
	0b00000010,
	0b00000100,
	0b00001000,
	0b00010001,
	0b00100010,
	0b01000100,
	0b10001000,
	0b00010001,
	0b00100010,
	0b01000100,
	0b10001000,
	0b00010001,
	0b00100010,
	0b01000100,
	0b10001000,
	0b00010001,
	0b00100010,
	0b01000100,
	0b10001000,
	0b00010000,
	0b00100000,
	0b01000000,
	0b10000000,

	0b00000001,
	0b00000011,
	0b00000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111111,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b10000111,
	0b11000011,
	0b11100001,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b11111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100001,
	0b11000011,
	0b10000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111111,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b10000111,
	0b11000011,
	0b11100001,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b11111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100001,
	0b11000011,
	0b10000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111111,
	0b01111111,
	0b00111111,
	0b00011111,
	0b00001111,
	0b10000111,
	0b11000011,
	0b11100001,
	0b11110000,
	0b11111000,
	0b11111100,
	0b11111110,
	0b11111111,
	0b11111110,
	0b11111100,
	0b11111000,
	0b11110000,
	0b11100001,
	0b11000011,
	0b10000111,
	0b00001111,
	0b00011111,
	0b00111111,
	0b01111111,
	0b11111111,

	0xFF,
	0xFF,
	0x00, 
	0x00,
	0x00,



	0x00
};

int GetPatternSizeP()
{
	return sizeof(testPatternP);
}
