#include <P16F648A.h>
#include <P16F648A_bits.h>
#include <PortBits.h>
#include <DataLib.h>

#define APROCFREQ 4000000

#define BITSIZE 14
#define BOOTADDRESS 0
#define FIRSTRAM 0x20
#define LASTRAM 0x1FF
#define HASOSCCAL 0
#define nPAGESRAM 4
#define nPAGESROM 2
//
// Header file - should be included in all C files used within the program
// This file is created automatically and should not be changed
//

//
// Functions
//
void UserInitialise();			// Your initialisation code
void UserInterrupt();			// Your interrupt code
void UserLoop();			// your Main loop code


#define PortOut8nCopy 1
// **********
//
// Port B Driver
//
// **********
#define PBDriveUsed 1
#pragma asmline _PBDriveUsed=1
#define PBDrive0 2
#define PBDrive_IntOc 0
#define PBDrive_RBOc 1
#define UsePU 1
#pragma asmline _UsePU=1
#define BIntEdge 1
#pragma asmline _BIntEdge=1
#define RB0Port PORTB
#define RB0Bit 0
#pragma asmline _RB0Port=PORTB
#pragma asmline _RB0Bit=0
#define RB1Port PORTB
#define RB1Bit 1
#pragma asmline _RB1Port=PORTB
#pragma asmline _RB1Bit=1
#define RB2Port PORTB
#define RB2Bit 2
#pragma asmline _RB2Port=PORTB
#pragma asmline _RB2Bit=2
#define RB3Port PORTB
#define RB3Bit 3
#pragma asmline _RB3Port=PORTB
#pragma asmline _RB3Bit=3
#define RB4Port PORTB
#define RB4Bit 4
#pragma asmline _RB4Port=PORTB
#pragma asmline _RB4Bit=4
#define RB5Port PORTB
#define RB5Bit 5
#pragma asmline _RB5Port=PORTB
#pragma asmline _RB5Bit=5
#define RB6Port PORTB
#define RB6Bit 6
#pragma asmline _RB6Port=PORTB
#pragma asmline _RB6Bit=6
#define RB7Port PORTB
#define RB7Bit 7
#pragma asmline _RB7Port=PORTB
#pragma asmline _RB7Bit=7
// **********
//
// Port Driver 8
//
// **********
#define PortOut8Used 1
#define PortOut80Used 1
#define PortOut80 1
#define InitialValue0_0 0
#define InitialValue1_0 0
#define InitialValue2_0 0
#define InitialValue3_0 0
#define InitialValue4_0 0
#define InitialValue5_0 0
#define InitialValue6_0 0
#define InitialValue7_0 0
#define Out0_0Port PORTA
#define Out0_0Bit 0
#define Out1_0Port PORTA
#define Out1_0Bit 1
#define Out2_0Port PORTA
#define Out2_0Bit 2
#define Out3_0Port PORTA
#define Out3_0Bit 3
#define Out4_0Port PORTA
#define Out4_0Bit 4
#define Out5_0Port PORTB
#define Out5_0Bit 7
#define Out6_0Port PORTA
#define Out6_0Bit 6
#define Out7_0Port PORTA
#define Out7_0Bit 7
// **********
//
// Interrupt Driven Serial Interface (62x)
//
// **********
#define SerInt62xUsed 1
#pragma asmline _SerInt62xUsed=1
#define SerInt62xIntUsed 1
#pragma asmline _SerInt62xIntUsed=1
#define SerInt62x0 0
#define SerInt62x_TxFree 0
#define SerInt62x_RxByte 1
#define SERINTRATE 19200
#pragma asmline _SERINTRATE=19200
#define USEXON 0
#pragma asmline _USEXON=0
#define RXBUFSZ 8
#pragma asmline _RXBUFSZ=8
#define TXBUFSZ 8
#pragma asmline _TXBUFSZ=8
#define RxPort PORTB
#define RxBit 1
#pragma asmline _RxPort=PORTB
#pragma asmline _RxBit=1
#define TxPort PORTB
#define TxBit 2
#pragma asmline _TxPort=PORTB
#pragma asmline _TxBit=2

// **********
//
// Application Designer Variables
//
// **********


// Defines specified by 1 or more elements

