#include "C:\\Users\\develop\\Documents\\dev\\onechip\\micon\\devTool200904\\firmware\\pic16f648a\\wizc\\DigitalInOut_Auto.h"

//
// This file includes all user definable routines. It may be changed at will as
// it will not be regenerated once the application has been generated for the
// first time.
//

// Global Working strages
unsigned char previousPortdValue;
unsigned char commandReqFlag;
unsigned char commandBuff[4];
unsigned char recieveLength;
unsigned char sendBuff[6];
int sendLength;
unsigned char portVal = 0;
unsigned char ledPortVal;

// Function prototype
unsigned char RecieveCommand();
void DoCommand(unsigned char cmnd);
void CheckPortChange();
void SendResultData();void SetLedPort(int val);
unsigned char GetSwitch();
void LedTest();

//*******************************************************************************
//
// Insert your interrupt handling code if required here. 
// Note quick interrupts are used so code must be simple
// See the manual for details of quick interrupts.
//

void UserInterrupt()
{
	// Insert your code here

 #asmline SETPCLATH UserIntReturn,-1  ; SETPCLATH for interrupt routine
 #asmline goto UserIntReturn	      ; Assembler - go back to interrupt routine
}


//*******************************************************************************
//
// Insert your initialisation code if required here. 
// Note that when this routine is called Interrupts will not be enabled - the 
// Application Designer will enable them before the main loop
//

void UserInitialise()
{
	recieveLength = 0;
	sendBuff[4] = 0x0D;
	sendBuff[5] = 0x0A;
	commandReqFlag = 0;
	sendLength = 0;
	previousPortdValue = GetSwitch();
	LedTest();
}

//*******************************************************************************
//
// Insert your main loop code if required here. This routine will be called
// as part of the main loop code
//

void UserLoop()
{
	DoCommand(RecieveCommand());		// ??????? & ???????
	if(sendLength <= 0) CheckPortChange();	// ??????????
	if(sendLength > 0) SendResultData();	// ??????
}

//
// User occurrence code
//

#define GET_HEX_BYTE(h) ( ((h) >= 0x40) ? (((h) & 0x0F) + 9):((h) & 0x0F) )
#define GET_HEX_CHAR(h) (((h) > 9)? ((h) + 0x41 - 10):((h) + 0x30))



/*---------------------------------------------
 *
 *		??????????
 *
 */
unsigned char GetSwitch()
{
	unsigned char work = PORTB;
	return (work & 0x78) | ((work  & 0x01) << 2);
}


/*---------------------------------------------
 *
 *		LED?????????
 *
 */
unsigned char GetLedPort()
{
	return ledPortVal;
//	unsigned char work1 = PORTA;
//	unsigned char work2 = PORTB >> 2;
//	work1 &= 0xDF;
//	work2 &= 0x20;
//	return ~(work1 | work2);
}


/*---------------------------------------------
 *
 *		LED??????
 *
 */
void SetLedPort(int val)
{
	ledPortVal = val;
	PORTA = ~val | 0x20;
	if(val & 0x20)
	{
		PORTB = 0x00;
	}
	else
	{
		PORTB = 0x80;
	}
}

/*---------------------------------------------
 *
 *		???????
 *
 */
unsigned char RecieveCommand()
{
	unsigned char result = 0;
	if(GetRxSize() != 0)		// ?????????
	{
		portVal = WaitRx();
		switch(portVal)
		{
		case 0x0D:
		case 0x0A:					// CR/LF????????????
			recieveLength = 0;
			break;
		default:
			if(recieveLength < 4)	// ????????????
				commandBuff[recieveLength++] = portVal;		// ?????????????
			break;
		}
		if(recieveLength > 1)
		{
			switch(commandBuff[0])
			{
			case 'R':
			case 'r':
				if(recieveLength == 2) result = 'R';
				break;
			case 'W':
			case 'w':
				if(recieveLength == 4) result = 'W';
				break;
			default:
				break;
			}
		}
	}
	return result;
}


/*---------------------------------------------
 *
 *		???????
 *
 */
void DoCommand(unsigned char cmnd)
{
	unsigned char work1, work2;
	switch(cmnd)
	{
	case 'R':
	case 'r':
		if((commandBuff[1] == 'D') || (commandBuff[1] == 'd'))
		{
			portVal = GetSwitch();
			sendLength = 6;
			commandReqFlag = 0;
		}
		if((commandBuff[1] == 'B') || (commandBuff[1] == 'b'))
		{
			portVal = GetLedPort();
			sendLength = 6;
			commandReqFlag = 0;
		}
		sendBuff[0] = 'P';
		sendBuff[1] = commandBuff[1] & 0xDF;
		work1 = (portVal >> 4) & 0x0F;
		sendBuff[2] = GET_HEX_CHAR(work1);
		work2 = portVal & 0x0F;
		sendBuff[3] = GET_HEX_CHAR(work2);
		recieveLength = 0;
		break;
	case 'W':
	case 'w':
		if((commandBuff[1] == 'B') || (commandBuff[1] == 'b'))
		{
			work1 = commandBuff[2];
			work1 = GET_HEX_BYTE(work1) << 4;
			work2 = commandBuff[3];
			work2 = GET_HEX_BYTE(work2);
			portVal = work1 | work2;
			SetLedPort(portVal);
		}
		recieveLength = 0;
		break;
	default:
		break;
	}
}

/*---------------------------------------------
 *
 *		?????????
 *
 */
void CheckPortChange()
{
	unsigned char work;
	if(previousPortdValue != GetSwitch())
	{
		previousPortdValue = GetSwitch();
		sendBuff[0] = 'C';
		sendBuff[1] = 'D';
		work = (previousPortdValue >> 4) & 0x0F;
		sendBuff[2] = GET_HEX_CHAR(work);
		work = previousPortdValue & 0x0F;
		sendBuff[3] = GET_HEX_CHAR(work);
		sendLength = 6;
	}
}

/*---------------------------------------------
 *
 *		??????
 *
 */
void SendResultData()
{
	if(GetTxSize() < 2)
	{
		portVal = sendBuff[6 - sendLength--];
		AddTx(portVal);
	}
}


/*---------------------------------------------
 *
 *		LED?????
 *
 */
void LedTest()
{
	unsigned char dataIndex = 0;
	short interval;
	while((GetSwitch() & 0x10) != 0)
	{
		interval = ((GetSwitch() & 0x08) != 0) ? 10000:2500;
		interval = ((GetSwitch() & 0x04) != 0) ? interval * 2:interval;
		SetLedPort(ReadEEData(dataIndex++));
		dataIndex &= 0x7F;
		for(unsigned int index = 0; index < interval; index++)
		{
		}
	}
	SetLedPort(0);
}

// EEPROM??Wiz-C ??????128?????
#eeprom		0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0xFF, 0xFF;		// 8 byte
#eeprom		0xFF, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF;		// 7 byte
#eeprom		0xFE, 0xFD, 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F;		// 8 byte
#eeprom		0xBF, 0xDF, 0xEF, 0xF7, 0xFB, 0xFD, 0xFE;		// 7 byte
#eeprom		0xFD, 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F; 		// 7 byte
#eeprom		0xBF, 0xDF, 0xEF, 0xF7, 0xFB, 0xFD, 0xFE;		// 7 byte
#eeprom		0xFC, 0xF8, 0xF0, 0xE0, 0xC0, 0x80, 0x00;		// 7 byte 
#eeprom		0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02;		// 7 byte
#eeprom		0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40;		// 7 byte
#eeprom		0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02;		// 7byte
#eeprom		0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40;		// 8 byte
#eeprom		0x80, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40;					// 4 byte
#eeprom		0x80, 0x01, 0x03, 0x06, 0x0C, 0x18, 0x30, 0x60;					// 4 byte
#eeprom		0xC0, 0x01, 0x03, 0x07, 0x0E, 0x1C, 0x38, 0xE0;					// 4 byte
#eeprom		0xC0, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01;					// 4 byte
#eeprom		0x80, 0xC0, 0x60, 0x30, 0x18, 0x0C, 0x06, 0x03, 0x01;					// 4 byte
#eeprom		0x80, 0xC0, 0xE0, 0xF0, 0xF8, 0xFC, 0xFE;					// 4 byte
