﻿Public Class AutoPattern

    Public Const PATTERNBUFFSIZE As Integer = 20000
    '----------------------------------------------------------
    '
    '       ワークエリア
    '
    '----------------------------------------------------------
    Public AutoCount As Integer = 0                 '自動カウンタ
    Dim AutoIntervalCount As Integer = 0            '自動周期カウンタ
    Dim Interval As Integer = 0                     '周期
    Public PortPatternSize As Integer = 0           'パターンデータのサイズ
    Public PortPattern(PATTERNBUFFSIZE) As Byte     'パターンテーブル

    '----------------------------------------------------------
    '
    '       コンストラクタ
    '
    '----------------------------------------------------------
    Sub New()
        Dim index As Integer
        'パターンテーブルに、初期データを設定する
        For index = 0 To PortPatternInit.Count - 1
            PortPattern(index) = PortPatternInit(index) And &HFF
        Next
        PortPatternSize = PortPatternInit.Count
        'パターンテーブルに、初期データを2倍長で設定する
        For index = 0 To PortPatternInit.Count - 1
            PortPattern(index * 2 + PortPatternSize) = PortPatternInit(index) And &HFF
            PortPattern(index * 2 + 1 + PortPatternSize) = PortPatternInit(index) And &HFF
        Next
        PortPatternSize = PortPatternSize + PortPatternInit.Count * 2
        'パターンテーブルに、初期データを4倍長で設定する
        For index = 0 To PortPatternInit.Count - 1
            PortPattern(index * 4 + PortPatternSize) = PortPatternInit(index) And &HFF
            PortPattern(index * 4 + 1 + PortPatternSize) = PortPatternInit(index) And &HFF
            PortPattern(index * 4 + 2 + PortPatternSize) = PortPatternInit(index) And &HFF
            PortPattern(index * 4 + 3 + PortPatternSize) = PortPatternInit(index) And &HFF
        Next
        PortPatternSize = PortPatternSize + PortPatternInit.Count * 4
    End Sub

    '----------------------------------------------------------
    '
    '       バイトデータの上下ビットを反転する
    '
    '----------------------------------------------------------
    Protected Function InvertByte(ByVal val As Byte) As Byte
        Dim work As Byte
        For index As Integer = 0 To 7
            work = work << 1
            If (val And 1) Then
                work = work + 1
            End If
            val = val >> 1
        Next
        Return work
    End Function

    '----------------------------------------------------------
    '
    '       タイマーから周期起動される処理
    '
    '----------------------------------------------------------
    Public Function TimeTick(ByVal switch As Byte) As Byte
        Dim NextValue As Byte
        Interval = ((switch And &HC) >> 2) + 1                      '周期を算出
        If ((AutoIntervalCount < 0) Or (AutoIntervalCount >= Interval)) Then    '自動周期カウンタを初期化
            AutoIntervalCount = 0
        End If
        AutoIntervalCount += 1                                      '自動周期カウンタを更新
        If (AutoIntervalCount >= Interval) Then                     '自動周期カウンタが周期を超えた？
            AutoIntervalCount = 0                                   '自動周期カウンタをゼロにする
            AutoCount += 1                                          '自動カウンタを更新
            If (AutoCount >= PortPatternSize) Then AutoCount = 0 '   自動カウンタがオーバーフローしたら、ゼロクリア
        End If
        NextValue = PortPattern(AutoCount) And &HFF                 'パターンテーブルから次のデータを取得
        If (switch And (1 << 5)) Then                               'switchのビット５がONなら
            NextValue = InvertByte(NextValue)                           '上下ビットを反転する
        End If
        If (switch And (1 << 4)) Then                               'switchのビット４がONなら
            NextValue = Not NextValue                                   'ビットデータをON/OFF反転する
        End If
        Return NextValue
    End Function


    '----------------------------------------------------------
    '
    '       初期パターン・テーブル
    '
    '----------------------------------------------------------
    Dim PortPatternInit() As Integer = { _
        &H101, &H102, &H104, &H108, &H110, &H120, &H140, &H180, _
        &H101, &H102, &H104, &H108, &H110, &H120, &H140, &H180, _
        &H101, &H102, &H104, &H108, &H110, &H120, &H140, &H180, _
 _
        &H101, &H102, &H104, &H108, &H111, &H122, &H144, &H188, _
        &H111, &H122, &H144, &H188, &H111, &H122, &H144, &H188, _
        &H111, &H122, &H144, &H188, &H111, &H122, &H144, &H188, _
 _
        &H111, &H123, &H146, &H18C, &H118, &H130, &H160, &H1C0, _
        &H181, &H103, &H106, &H10C, &H118, &H130, &H160, &H1C0, _
        &H181, &H103, &H106, &H10C, &H118, &H130, &H160, &H1C0, _
 _
        &H181, &H103, &H106, &H10C, &H118, _
        &H131, &H163, &H1C6, &H18C, &H118, _
        &H131, &H163, &H1C6, &H18C, &H118, _
        &H131, &H163, &H1C6, &H18C, &H118, _
        &H131, &H163, &H1C6, &H18C, &H118, _
 _
        &H131, &H163, _
        &H1C7, &H18E, &H11C, &H138, &H171, &H1E3, _
        &H1C7, &H18E, &H11C, &H138, &H171, &H1E3, _
        &H1C7, &H18E, &H11C, &H138, &H171, &H1E3, _
        &H1C7, &H18E, &H11C, &H138, _
 _
        &H170, &H1E1, &H1C3, &H186, &H10C, &H118, _
        &H130, &H161, &H1C3, &H186, &H10C, &H118, _
        &H130, &H161, &H1C3, &H186, &H10C, &H118, _
        &H130, &H161, &H1C3, &H186, &H10C, &H118, _
        &H130, &H161, &H1C3, &H186, &H10C, &H118, _
        &H130, &H160, &H1C0, &H180, _
 _
        &H101, &H102, &H104, &H108, &H110, &H120, &H140, &H180, _
        &H101, &H102, &H104, &H108, &H110, &H120, &H140, &H180, _
 _
        &H101, _
        &H102, _
        &H104, _
        &H108, _
        &H110, &H110, _
        &H120, &H120, &H120, &H120, _
        &H140, &H140, &H141, &H142, &H144, &H142, &H141, &H140, _
        &H180, &H180, &H181, &H181, &H182, &H182, &H184, &H184, _
        &H188, &H188, &H190, &H190, &H188, &H188, &H184, &H184, _
        &H188, &H188, &H190, &H190, &H190, &H188, &H188, &H188, _
        &H184, &H184, &H184, &H188, &H188, &H188, &H184, &H184, _
        &H184, &H184, &H182, &H182, &H182, &H182, &H181, &H181, _
        &H181, &H181, &H180, &H180, &H180, &H180, &H100, &H100, _
        &H180, &H180, &H100, &H100, &H180, &H180, &H100, &H100 _
    }

End Class
