﻿
Imports System
Imports System.IO.Ports
Imports System.Threading

'==========================================================
'
'       Sample Application Type 2
'
'==========================================================
Public Class Sample2
    'Delegate Sub UpdatePB(ByVal val As Byte)           '
    'Delegate Sub UpdatePD(ByVal val As Byte)           '
    'Public UpdatePortBDelegate As UpdatePB             '
    'Public UpdatePortDDelegate As UpdatePD             '

    Dim ThreadContinue As Boolean                       'スレッド処理継続フラグ
    Dim AutoControl As AutoPattern = New AutoPattern    '自動パターン送出クラス

    '----------------------------------------------------------
    '
    '       コンストラクタ
    '
    '----------------------------------------------------------
    Sub New()

        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。

        'UpdatePortBDelegate = New UpdatePB(AddressOf UpdatePortB)
        'UpdatePortDDelegate = New UpdatePD(AddressOf UpdatePortD)
        ImageList1.Images.SetKeyName(0, PortView.PortView.BITOFF)               'BitOffのイメージにキー名を付与
        ImageList1.Images.SetKeyName(1, PortView.PortView.BITON)                'BitOnのイメージにキー名を付与
        ImageList1.Images.SetKeyName(2, PortView.PortViewWithEnable.SWITCHOFF)  'SwitchOffのイメージにキー名を付与
        ImageList1.Images.SetKeyName(3, PortView.PortViewWithEnable.SWITCHON)   'SwitchOnのイメージにキー名を付与
        ImageList1.Images.SetKeyName(4, PortView.PortViewWithEnable.SWITCHNA)   'SwitchNAのイメージにキー名を付与
        PortBView.ImageAdd(PortView.PortView.BITOFF, ImageList1.Images(PortView.PortView.BITOFF))   'BitOffのイメージを登録
        PortBView.ImageAdd(PortView.PortView.BITON, ImageList1.Images(PortView.PortView.BITON))     'BitOnのイメージを登録
        PortBView.ShowValue()
        PortDView.ImageAdd(PortView.PortViewWithEnable.SWITCHOFF, ImageList1.Images(PortView.PortViewWithEnable.SWITCHOFF)) 'SwitchOffのイメージを登録
        PortDView.ImageAdd(PortView.PortViewWithEnable.SWITCHON, ImageList1.Images(PortView.PortViewWithEnable.SWITCHON))   'SwitchOnのイメージを登録
        PortDView.ImageAdd(PortView.PortViewWithEnable.SWITCHNA, ImageList1.Images(PortView.PortViewWithEnable.SWITCHNA))   'SwitchNAのイメージを登録
        PortDView.ShowValue()

        PortList.Items.Clear()                                  '通信ポート名リストをクリア
        PortList.Items.Add("Close")                             '先頭にCloseを設定
        Dim portName As String
        For Each portName In SerialPort.GetPortNames()          'SerialPortクラスで、通信ポート名のコレクションを取得し、各要素に対して
            PortList.Items.Add(portName)                        '通信ポート名リストに追加する
        Next portName

        ThreadContinue = True                                   'スレッド継続フラグをセットする
        BackgroundWorker1.RunWorkerAsync()                      'スレッドを起動する
    End Sub


    '----------------------------------------------------------
    '
    '       クローズボタンの処理
    '
    '----------------------------------------------------------
    Private Sub CloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Close()         'フォームをクローズする
    End Sub

    '----------------------------------------------------------
    '
    '
    '
    '----------------------------------------------------------
    Private Sub Sample2_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        ThreadContinue = False          ' 無限ループを終わらせるフラグの設定
        If SerialPort1.IsOpen Then      ' もし、通信ポートがオープンなら
            SerialPort1.Close()         '   通信ポートをクローズして、Readlineを異常終了させる  
        End If
        Thread.Sleep(10)                ' Sleepで時間待ちしていることがあるので、終了を待つ
    End Sub

    '----------------------------------------------------------
    '
    '       ポートBの値を設定し、表示を更新する
    '
    '----------------------------------------------------------
    Public Sub UpdatePortB(ByVal val As Byte)
        PortBView.Value = val
    End Sub

    '----------------------------------------------------------
    '
    '       ポートDの値を設定し、表示を更新する
    '
    '----------------------------------------------------------
    Public Sub UpdatePortD(ByVal val As Byte)
        PortDView.Value = val
    End Sub

    '----------------------------------------------------------
    '
    '       通信ポートに、通信メッセージを送出する
    '
    '----------------------------------------------------------
    Private Sub WritePort(ByVal cmnd As String, ByVal portName As String, ByVal portVal As Integer)
        Dim valString As String
        If SerialPort1.IsOpen Then      '通信ポートがオープンされていれば、
            If (cmnd = "W") Then        '  もし、書き込みコマンドのとき
                valString = String.Format("{0}{1}{2:X2}", cmnd, portName, (portVal And &HFF))   'データつきのメッセージを作成する
            Else
                valString = String.Format("{0}{1}", cmnd, portName)         'データ無しのメッセージを作成する
            End If
            Try
                SerialPort1.WriteLine(valString)                            'メッセージを通信ポートに出力する
            Catch
            End Try
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       通信ポートリストの設定が変更されたときの処理
    '
    '----------------------------------------------------------
    Private Sub PortList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PortList.SelectedIndexChanged
        SwitchButton.Tag = 1                        'ポートD値のマウスでの変更を禁止
        SwitchButton.BackColor = Color.DodgerBlue   'ボタンを色を変える
        If SerialPort1.IsOpen Then                  '通信ポートが開いていれば、
            SerialPort1.Close()                     '  閉じる
        End If

        If (PortList.SelectedIndex > 0) Then        '選択が有効であれば、
            SerialPort1.PortName = PortList.SelectedItem    'ポート名を取得し、通信ポートに設定する
            Try
                SerialPort1.Open()                      '通信ポートを開く
                WritePort("R", "B", 0)                  'ポートB読込みコマンドを送出
                Thread.Sleep(1)
                WritePort("R", "D", 0)                  'ポートD読込みコマンドを送出
            Catch
                PortList.SelectedIndex = 0              '通信ポートのオープンに失敗したら、通信ポート選択をClose状態にする
            End Try
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       16進文字を数値に変換する
    '
    '----------------------------------------------------------
    Private Shared Function GetHexDigit(ByVal dig As Char) As Byte
        If (Asc(dig) <= Asc("A")) Then
            Return (Asc(dig) And &HF)
        Else
            Return ((Asc(dig) And &HF) + 9)
        End If
    End Function

    '----------------------------------------------------------
    '
    '       スレッドの処理
    '
    '----------------------------------------------------------
    Private Sub BackgroundWorker1_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Dim newValue As Byte
        Dim recvMessage As String
        While (ThreadContinue)                  'スレッド継続フラグがONの間、繰返す
            If (SerialPort1.IsOpen) Then            'もし、通信ポートが開いていれば、
                Try
                    recvMessage = SerialPort1.ReadLine()    '通信ポートから1行読み込む
                    newValue = (GetHexDigit(recvMessage.Substring(2, 1)) << 4) + GetHexDigit(recvMessage.Substring(3, 1))   'データを取得する
                    If (recvMessage.Substring(1, 1) = "B") Then             'ポートBの値か？
                        'Invoke(UpdatePortBDelegate, newValue)                  ’
                        BackgroundWorker1.ReportProgress(newValue Or &H100)     'ポートBの変更をレポート
                    ElseIf (recvMessage.Substring(1, 1) = "D") Then         'ポートDの値か？
                        'Invoke(UpdatePortDDelegate, newValue)                  ’
                        BackgroundWorker1.ReportProgress(newValue Or &H200)     'ポートDの変更をレポート
                    End If
                Catch
                End Try
            Else
                Thread.Sleep(5)         '通信ポートが開いていなければ、５ｍS待つ
            End If
        End While
    End Sub

    '----------------------------------------------------------
    '
    '       ポート値が変更されたときの処理
    '
    '----------------------------------------------------------
    Private Sub BackgroundWorker1_ProgressChanged(ByVal sender As System.Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles BackgroundWorker1.ProgressChanged
        Dim cmnd As Integer
        cmnd = e.ProgressPercentage                 'レポート内容を取得
        If (cmnd And &HF00) = &H100 Then            'ポートB変更か？
            PortBView.Value = (cmnd And &HFF)           'ポートBの値を設定＆表示の更新
        ElseIf (cmnd And &HF00) = &H200 Then        'ポートD変更か？
            PortDView.Value = (cmnd And &HFF)           'ポートDの値を設定＆表示の更新
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       マウスでポートBを変更したときの処理
    '
    '----------------------------------------------------------
    Private Sub PortBView_PortValueChanged(ByVal sender As PortView.PortView, ByVal bitPosition As System.Int32) Handles PortBView.PortValueChanged
        PortBView.NotBit(bitPosition)               'ポートBの当該ビットを反転する
        WritePort("W", "B", PortBView.Value)        'ファームウェアに変更値を書き込む
    End Sub

    '----------------------------------------------------------
    '
    '       マウスでポートDを変更したときの処理
    '
    '----------------------------------------------------------
    Private Sub PortDView_PortValueChanged(ByVal sender As PortView.PortView, ByVal bitPosition As System.Int32) Handles PortDView.PortValueChanged
        If (SwitchButton.Tag = 0) Or (Not SerialPort1.IsOpen) Then  'ポートD値変更許可状態か、通信ポートがクローズのとき、
            PortDView.NotBit(bitPosition)           'ポートDの当該ビットを反転する
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       タイマーの割り込み処理
    '
    '----------------------------------------------------------
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If (PortDView.Value And &H40) Then          'PD6がONのとき、
            PortBView.Value = AutoControl.TimeTick(PortDView.Value) '自動パターン送出処理で次に送出するパターンを取得し、ポートB値に設定する
            WritePort("W", "B", PortBView.Value)    'ファームウェアに新しい値を書き込む
        End If
    End Sub


    '==========================================================
    '
    '       フォームを移動する
    '
    '==========================================================
    Private mouseOffset As Point                    '移動距離算出用ワーク
    Private isMouseDown As Boolean = False          'マウス操作検定用フラグ

    '----------------------------------------------------------
    '
    '       マウスの左ボタンが押下されると、フォーム移動の開始
    '
    '----------------------------------------------------------
    Private Sub Form1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown, TitleLabel.MouseDown, CopyrightLabel.MouseDown
        If (e.Button = Windows.Forms.MouseButtons.Left) Then        '左ボタン押下か？
            mouseOffset = Control.MousePosition                         'スクリーン座標でマウス位置取得
            mouseOffset.X = Location.X - mouseOffset.X                  'ウィンドウ左上端からの相対位置を計算
            mouseOffset.Y = Location.Y - mouseOffset.Y                  '
            isMouseDown = True                                          'マウスダウンフラグをセットする
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       マウスの左ボタンが押下されたまま移動すると、フォームの移動
    '
    '----------------------------------------------------------
    Private Sub Form1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove, TitleLabel.MouseMove, CopyrightLabel.MouseMove
        Dim currMousePosition As Point
        If isMouseDown Then                                         'マウスダウンのままか？
            currMousePosition = Control.MousePosition                   'スクリーン座量でマウス位置取得
            currMousePosition.Offset(mouseOffset)                       'ウィンドウ左上端の新しい座標を計算
            Location = currMousePosition                                'ウィンドウを移動する
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       マウスの左ボタンが放されると、フォーム移動の終了
    '
    '----------------------------------------------------------
    Private Sub Form1_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp, TitleLabel.MouseUp, CopyrightLabel.MouseUp
        If (e.Button = Windows.Forms.MouseButtons.Left) Then        '左ボタンを放したか？
            isMouseDown = False                                         'マウスダウンフラグをリセットする
        End If
    End Sub

    '==========================================================
    '
    '       パターン編集
    '
    '==========================================================
    Private Sub EditButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditButton.Click
        Dim dlg As PatternEdit = New PatternEdit                        'パターン編集ダイアログを生成   
        For index As Integer = 0 To AutoPattern.PATTERNBUFFSIZE         'パターンテーブルをコピー
            dlg.PortPattern(index) = AutoControl.PortPattern(index)
        Next
        dlg.PortPatternSize = AutoControl.PortPatternSize               'パターンサイズをセット
        dlg.ImageAdd(PortView.PortViewEdit.BITOFF, ImageList1.Images(PortView.PortViewEdit.BITOFF)) 'BitOffイメージをセット
        dlg.ImageAdd(PortView.PortViewEdit.BITON, ImageList1.Images(PortView.PortViewEdit.BITON))   'BitOnイメージをセット
        If dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then        '編集画面を表示する。OKで終了したか？
            For index As Integer = 0 To AutoPattern.PATTERNBUFFSIZE         'パターン編集テーブルを更新
                AutoControl.PortPattern(index) = dlg.PortPattern(index)
            Next
            AutoControl.PortPatternSize = dlg.PortPatternSize               'パターンサイズを更新
            AutoControl.AutoCount = 0                                       '自動カウンタをリセット
        End If
    End Sub

    '==========================================================
    '
    '       ポートD値変更許可ボタン
    '
    '==========================================================
    Private Sub SwitchButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SwitchButton.Click
        If SerialPort1.IsOpen Then                                      '通信ポートがオープンなら、
            If sender.tag = 0 Then                                          'タグがOFFなら、
                sender.tag = 1                                                  'タグをONにする（ポートD値変更禁止）
                CType(sender, Button).BackColor = Color.DodgerBlue              'ボタンの背景色を変える
                WritePort("R", "D", 0)                                          'ファームウェアにポートDの読込みを指示
            Else                                                            'タグがONなら
                sender.tag = 0                                                  'タグをOFFにする（ポートD値変更許可）
                CType(sender, Button).BackColor = Color.Pink                    'ボタンの背景色を変える
            End If
        End If
    End Sub

    '==========================================================
    '
    '       About表示
    '
    '==========================================================
    Private Sub CeramicButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CeramicButton.Click
        Dim dlg As AboutDialog = New AboutDialog
        dlg.ShowDialog()
    End Sub

End Class
