﻿
Imports System
Imports System.IO.Ports
Imports System.Threading

'==========================================================
'
'       Sample3: 超簡単リアルタイム・アプリケーション
'
'==========================================================
Public Class Sample3
    'Delegate Sub UpdatePB(ByVal val As Integer)
    'Delegate Sub UpdatePD(ByVal val As Integer)
    'Public UpdatePortBDelegate As UpdatePB
    'Public UpdatePortDDelegate As UpdatePD

    Dim ThreadContinue As Boolean
    Dim AutoControl As AutoPattern = New AutoPattern
    Dim toolTipLabelTimer As Integer

    '----------------------------------------------------------
    '
    '       コンストラクタ
    '
    '----------------------------------------------------------
    Sub New()

        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。

        'UpdatePortBDelegate = New UpdatePB(AddressOf UpdatePortB)
        'UpdatePortDDelegate = New UpdatePD(AddressOf UpdatePortD)
        ImageList1.Images.SetKeyName(0, PortView.PortView.BITOFF)
        ImageList1.Images.SetKeyName(1, "RED_CIRCLE")
        ImageList1.Images.SetKeyName(2, "GREEN_CIRCLE")
        ImageList1.Images.SetKeyName(3, "BLUE_CIRCLE")
        ImageList1.Images.SetKeyName(4, PortView.PortViewWithEnable.SWITCHOFF)
        ImageList1.Images.SetKeyName(5, PortView.PortViewWithEnable.SWITCHON)
        ImageList1.Images.SetKeyName(6, PortView.PortViewWithEnable.SWITCHNA)
        PortBView.ImageAdd(PortView.PortView.BITOFF, ImageList1.Images(PortView.PortView.BITOFF))
        PortBView.ImageAdd(PortView.PortView.BITON, ImageList1.Images("RED_CIRCLE"))
        PortBView.ShowValue()
        PortDView.ImageAdd(PortView.PortViewWithEnable.SWITCHOFF, ImageList1.Images(PortView.PortViewWithEnable.SWITCHOFF))
        PortDView.ImageAdd(PortView.PortViewWithEnable.SWITCHON, ImageList1.Images(PortView.PortViewWithEnable.SWITCHON))
        PortDView.ImageAdd(PortView.PortViewWithEnable.SWITCHNA, ImageList1.Images(PortView.PortViewWithEnable.SWITCHNA))
        PortDView.ShowValue()
        CloseButton.BackgroundImage = ImageList1.Images(1)
        DeviceList.SelectedIndex = 0
        PortList.Items.Clear()
        PortList.Items.Add("Close")
        Dim portName As String
        For Each portName In SerialPort.GetPortNames()
            PortList.Items.Add(portName)
        Next portName
        PortList.SelectedIndex = 0
        toolTipLabelTimer = 0


        ThreadContinue = True
        BackgroundWorker1.RunWorkerAsync()
        BackgroundWorker2.RunWorkerAsync()
    End Sub


    '----------------------------------------------------------
    '
    '       クローズボタンのクリックイベント処理
    '
    '----------------------------------------------------------
    Private Sub CloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseButton.Click
        Close()
    End Sub

    '----------------------------------------------------------
    '
    '       フォームがクローズされるときの処理
    '
    '----------------------------------------------------------
    Private Sub Sample2_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        ThreadContinue = False          ' 無限ループを終わらせるフラグの設定
        If SerialPort1.IsOpen Then      ' もし、通信ポートがオープンなら
            SerialPort1.Close()         '   通信ポートをクローズして、Readlineを異常終了させる  
        End If
        Thread.Sleep(60)                ' Sleepで時間待ちしていることがあるので、終了を待つ
    End Sub

    '----------------------------------------------------------
    '
    '       ポートBの値を設定し、表示を更新する
    '
    '----------------------------------------------------------
    Public Sub UpdatePortB(ByVal val As Integer)
        PortBView.Value = val
    End Sub

    '----------------------------------------------------------
    '
    '       ポートDの値を設定し、表示を更新する
    '
    '----------------------------------------------------------
    Public Sub UpdatePortD(ByVal val As Integer)
        PortDView.Value = val
    End Sub

    '----------------------------------------------------------
    '
    '       ファームウェアにコマンドを出力する
    '
    '----------------------------------------------------------
    Private SerialPortWriteLock As Object = New Object
    Private Sub WritePort(ByVal cmnd As String, ByVal portName As String, ByVal portVal As Integer)
        SyncLock SerialPortWriteLock
            Dim valString As String
            If SerialPort1.IsOpen Then
                If (cmnd = "W") Then
                    valString = String.Format("{0}{1}{2:X2}", cmnd, portName, (portVal And &HFF))
                Else
                    valString = String.Format("{0}{1}", cmnd, portName)
                End If
                Try
                    If lastDeviceIndex = 2 Then
                        SerialPort1.Write(valString + vbCr)     '2008年8月号付録78K0用 0x0Dで終端しないと受信データが上がってこない
                    Else
                        SerialPort1.Write(valString + vbCrLf)
                    End If
                Catch
                End Try
            End If
        End SyncLock
    End Sub

    '----------------------------------------------------------
    '
    '       ポートリストで、通信ポートが選択されたときの処理
    '
    '----------------------------------------------------------
    Private Sub PortList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PortList.SelectedIndexChanged
        SwitchButton.Tag = 1
        SwitchButton.BackColor = Color.DodgerBlue
        If SerialPort1.IsOpen Then
            SerialPort1.Close()
            DeviceList.Enabled = True
        End If

        If ((PortList.SelectedIndex > 0) And (PortList.SelectedIndex < PortList.Items.Count)) Then
            SerialPort1.PortName = PortList.SelectedItem
            Try
                If lastDeviceIndex = 2 Then         ' device == 78K0
                    SerialPort1.BaudRate = 38400
                Else
                    SerialPort1.BaudRate = 9600
                End If
                SerialPort1.Open()
                SerialPort1.Write(vbCr)
                If lastDeviceIndex = 2 Then         ' device == 78K0
                    SerialPort1.Write("jmp 2000" & vbCr)    'トラ技ＢＩＯＳ起動時、ＲＯＭからスタート
                    Thread.Sleep(100)
                End If
                SerialPort1.Write(vbCr)
                WritePort("R", "B", 0)
                Thread.Sleep(1)
                WritePort("R", "D", 0)
                DeviceList.Enabled = False
            Catch
                PortList.SelectedIndex = 0
                DeviceList.Enabled = True
            End Try
        End If
    End Sub

    '----------------------------------------------------------
    '
    '           16進文字を数値に変換する
    '
    '----------------------------------------------------------
    Private Shared Function GetHexDigit(ByVal dig As Char) As Byte
        If (Asc(dig) <= Asc("A")) Then
            Return (Asc(dig) And &HF)
        Else
            Return ((Asc(dig) And &HF) + 9)
        End If
    End Function

    '----------------------------------------------------------
    '
    '           データ受信を行うスレッド
    '
    '----------------------------------------------------------
    Dim recvMessage As String = ""
    Private Sub BackgroundWorker1_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Dim newValue As Byte
        Dim newChar As Integer
        While ThreadContinue
            If SerialPort1.IsOpen Then
                Try
                    While ThreadContinue
                        newChar = SerialPort1.ReadByte()
                        If newChar >= &H20 Then
                            recvMessage &= Chr(newChar)
                        Else
                            recvMessage = ""
                        End If
                        If recvMessage.Length >= 4 Then Exit While
                    End While
                    If recvMessage.Length >= 4 Then
                        newValue = (GetHexDigit(recvMessage.Substring(2, 1)) << 4) + GetHexDigit(recvMessage.Substring(3, 1))
                        If (recvMessage.Substring(1, 1) = "B") Then
                            'Invoke(UpdatePortBDelegate, newValue)
                            BackgroundWorker1.ReportProgress(newValue Or &H100)
                        ElseIf (recvMessage.Substring(1, 1) = "D") Then
                            'Invoke(UpdatePortDDelegate, newValue)
                            BackgroundWorker1.ReportProgress(newValue Or &H200)
                        End If
                        recvMessage = ""
                    End If
                Catch ex As TimeoutException
                    Thread.Sleep(20)
                Catch
                    BackgroundWorker1.ReportProgress(&H0)
                End Try
            Else
                Thread.Sleep(50)
            End If
        End While
    End Sub

    '----------------------------------------------------------
    '
    '       ポートデータ受信後の処理
    '
    '           メインスレッドで、データ設定と画面の更新を行う
    '
    '----------------------------------------------------------
    Private Sub BackgroundWorker1_ProgressChanged(ByVal sender As System.Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles BackgroundWorker1.ProgressChanged
        Dim cmnd As Integer
        cmnd = e.ProgressPercentage
        If cmnd = &H0 Then
            SerialPort1.Close()
            PortList.SelectedIndex = 0
        ElseIf (cmnd And &HF00) = &H100 Then
            PortBView.Value = (cmnd And &HFF)
        ElseIf (cmnd And &HF00) = &H200 Then
            PortDView.Value = (cmnd And &HFF)
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       ポートＢの画像がクリックされたときの処理
    '
    '----------------------------------------------------------
    Private Sub PortBView_PortValueChanged(ByVal sender As PortView.PortView, ByVal bitPosition As System.Int32) Handles PortBView.PortValueChanged
        PortBView.NotBit(bitPosition)
        PortBView.ShowBit(bitPosition)   ' bit x の表示を更新する
        WritePort("W", "B", PortBView.Value)
    End Sub

    '----------------------------------------------------------
    '
    '       ポートＤ（スィッチ）の画像がクリックされたときの処理
    '
    '----------------------------------------------------------
    Private Sub PortDView_PortValueChanged(ByVal sender As PortView.PortView, ByVal bitPosition As System.Int32) Handles PortDView.PortValueChanged
        If (SwitchButton.Tag = 0) Or (Not SerialPort1.IsOpen) Then
            PortDView.NotBit(bitPosition)
            PortDView.ShowBit(bitPosition)   ' bit x の表示を更新する
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       自動パターン送出処理        タイマーから５０ｍS毎に起動される
    '
    '----------------------------------------------------------
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If (PortDView.Value And &H40) Then
            'PortBView.Value = AutoControl.TimeTick(PortDView.Value)             '自動処理をメインスレッドで実行
            'WritePort("W", "B", PortBView.Value)
        End If
        If toolTipLabel.Visible Then
            toolTipLabelTimer += 1
            If toolTipLabelTimer > 50 Then      '約１秒でツールチップを消す
                ToolTipLabel.Visible = False
            End If
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       自動パターン送出処理        スレッド内のSleepで概ね５０ｍS毎に送出
    '
    '----------------------------------------------------------
    Private Sub BackgroundWorker2_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker2.DoWork
        Dim newValue As Integer
        While (ThreadContinue)
            If (PortDView.Value And &H40) Then
                newValue = AutoControl.TimeTick(PortDView.Value)         '自動処理をバックグランドで実行
                If SerialPort1.IsOpen Then
                    WritePort("W", "B", newValue)
                    WritePort("R", "B", newValue)       '通信時はファームウェアからのデータ送信でポートＢ画面の更新を行う
                Else
                    'Invoke(UpdatePortBDelegate, newValue)
                    BackgroundWorker1.ReportProgress(newValue Or &H100) 'オフライン時は、イベントを生成してメインスレッドで画面更新する
                End If
            End If
            Thread.Sleep(49)
        End While
    End Sub

    '----------------------------------------------------------
    '
    '       画面の移動処理　　MouseDown/MouseMove/MouseUpで一連の移動を行う
    '
    '----------------------------------------------------------
    Private mouseOffset As Point
    Private isMouseDown As Boolean = False

    Private Sub Form1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown, CopyrightLabel.MouseDown
        If (e.Button = Windows.Forms.MouseButtons.Left) Then
            mouseOffset = Control.MousePosition - Location
            isMouseDown = True
        End If
    End Sub

    Private Sub Form1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove, CopyrightLabel.MouseMove
        If isMouseDown Then
            Location = Control.MousePosition - mouseOffset
        End If
    End Sub

    Private Sub Form1_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp, CopyrightLabel.MouseUp
        If (e.Button = Windows.Forms.MouseButtons.Left) Then
            isMouseDown = False
        End If
    End Sub

    '----------------------------------------------------------
    '
    '       送出パターン編集処理の呼び出し
    '
    '----------------------------------------------------------
    Private Sub EditButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditButton.Click
        Dim dlg As PatternEdit = New PatternEdit
        ToolTipLabel.Visible = False
        For index As Integer = 0 To AutoPattern.PATTERNBUFFSIZE - 1
            dlg.PortPattern(index) = AutoControl.PortPattern(index)
            'For indexLoop As Integer = 0 To 10000                     '起動を遅くして、バックグランド処理を確認する
            'Next
        Next
        dlg.PortPatternSize = AutoControl.PortPatternSize
        If dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            For index As Integer = 0 To AutoPattern.PATTERNBUFFSIZE - 1
                AutoControl.PortPattern(index) = dlg.PortPattern(index)
            Next
            AutoControl.PortPatternSize = dlg.PortPatternSize
            AutoControl.AutoCount = 0
        End If
    End Sub

    '----------------------------------------------------------
    '
    '           スィッチの手動操作許可／禁止    （通信中だけ動作する）
    '
    '----------------------------------------------------------
    Private Sub SwitchButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SwitchButton.Click
        If SerialPort1.IsOpen Then
            If sender.tag = 0 Then
                sender.tag = 1
                CType(sender, Button).BackColor = Color.DodgerBlue
                WritePort("R", "D", 0)
            Else
                sender.tag = 0
                CType(sender, Button).BackColor = Color.Pink
            End If
        End If
    End Sub

    '----------------------------------------------------------
    '
    '           アバウト・ダイアログの表示
    '
    '----------------------------------------------------------
    Private Sub CeramicButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CeramicButton.Click
        Dim dlg As AboutDialog = New AboutDialog
        ToolTipLabel.Visible = False
        dlg.ShowDialog()
    End Sub


    '----------------------------------------------------------
    '
    '           デバイスを変更する
    '
    '----------------------------------------------------------
    Dim lastDeviceIndex As Integer = 0
    Private Sub DeviceList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeviceList.SelectedIndexChanged
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(Sample3))
        If Not SerialPort1.IsOpen Then
            Select Case DeviceList.SelectedIndex
                Case 0                                          ' ---------- ATtiny2313 ----------
                    BackgroundImage = Button1.BackgroundImage
                    DeviceList.Location = New Point(28, 70)
                    DeviceList.Size = New Size(108, 20)
                    PortList.Location = New Point(224, 70)
                    PortBView.ImageAdd(PortView.PortView.BITON, ImageList1.Images("RED_CIRCLE"))
                    PortDView.BitDisplay = &H7F
                    PortDView.BitEnable = &H7F
                    EditButton.Location = New Point(18, 64)
                    EditButton.Size = New Size(8, 18)
                    EditButton.BackgroundImage = CType(resources.GetObject("EditButton.BackgroundImage"), System.Drawing.Image)
                    SwitchButton.Location = New Point(138, 64)
                    SwitchButton.Size = New Size(7, 14)
                    CeramicButton.Location = New Point(121, 81)
                    CeramicButton.Size = New Size(8, 14)
                    CeramicButton.BackColor = Color.Transparent
                    Text = "Sample3 - Atmel ATtiny2313"
                Case 1                                              ' ---------- PIC16F648A ----------
                    BackgroundImage = Button2.BackgroundImage
                    DeviceList.Location = New Point(41, 71)
                    DeviceList.Size = New Size(94, 20)
                    PortList.Location = New Point(224, 70)
                    PortBView.ImageAdd(PortView.PortView.BITON, ImageList1.Images("GREEN_CIRCLE"))
                    PortDView.BitDisplay = &H7E
                    PortDView.BitEnable = &H7C
                    EditButton.Location = New Point(31, 65)
                    EditButton.Size = New Size(8, 18)
                    SwitchButton.Location = New Point(138, 65)
                    SwitchButton.Size = New Size(7, 14)
                    CeramicButton.Location = New Point(121, 81)
                    CeramicButton.Size = New Size(8, 14)
                    CeramicButton.BackColor = Color.Transparent
                    Text = "Sample3 - Microchip PIC16F648A"
                Case 2                                              ' ---------- 78K0 USB MICON ----------
                    BackgroundImage = Button3.BackgroundImage
                    DeviceList.Location = New Point(140, 60)
                    DeviceList.Size = New Size(110, 20)
                    PortList.Location = New Point(237, 81)
                    PortBView.ImageAdd(PortView.PortView.BITON, ImageList1.Images("BLUE_CIRCLE"))
                    PortDView.BitDisplay = &H7C
                    PortDView.BitEnable = &H7C
                    EditButton.Location = New Point(29, 75)
                    EditButton.Size = New Size(8, 18)
                    EditButton.BackgroundImage = Nothing
                    EditButton.BackColor = Color.DodgerBlue
                    SwitchButton.Location = New Point(50, 75)
                    SwitchButton.Size = New Size(8, 18)
                    CeramicButton.Location = New Point(71, 75)
                    CeramicButton.Size = New Size(8, 18)
                    CeramicButton.BackColor = Color.DodgerBlue
                    Text = "Sample3 - 78K0 USBマイコン　トラ技2008-08付録"
                Case Else

            End Select
            lastDeviceIndex = DeviceList.SelectedIndex
            PortBView.ShowValue()
        Else
            DeviceList.SelectedIndex = lastDeviceIndex
        End If
    End Sub

    '----------------------------------------------------------
    '
    '           ボタンにTIPを表示する
    '
    '----------------------------------------------------------
    Private Sub EditButton_MouseHover(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditButton.MouseHover
        toolTipLabel.Text = "パターンテーブルを編集する"
        ToolTipLabel.Location = Control.MousePosition() - Location + New Point(-5, -20)
        toolTipLabel.AutoSize = True
        toolTipLabel.BringToFront()
        toolTipLabel.Visible = True
        toolTipLabelTimer = 0
    End Sub

    Private Sub SwitchButton_MouseHover(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SwitchButton.MouseHover
        toolTipLabel.Text = "スィッチを手動で設定する"
        ToolTipLabel.Location = Control.MousePosition() - Location + New Point(-5, -20)
        toolTipLabel.AutoSize = True
        toolTipLabel.BringToFront()
        toolTipLabel.Visible = True
        toolTipLabelTimer = 0
    End Sub

    Private Sub CeramicButton_MouseHover(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CeramicButton.MouseHover
        toolTipLabel.Text = "About画面を表示する"
        ToolTipLabel.Location = Control.MousePosition() - Location + New Point(-5, -20)
        toolTipLabel.AutoSize = True
        toolTipLabel.BringToFront()
        toolTipLabel.Visible = True
        toolTipLabelTimer = 0
    End Sub

    Private Sub ToolTip_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SwitchButton.MouseLeave, EditButton.MouseLeave, CeramicButton.MouseLeave
        ToolTipLabel.Visible = False
    End Sub
End Class
